
// Sample0Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sample0.h"
#include "Sample0Dlg.h"
#include "afxdialogex.h"

#include "AIO167.h"
#include "AIO16A.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// Array of data displays:
float	*VoltsDisplay[16];
float	*DACDisplay[2];

// Card info:
int channels = 16;
double dac0mult, dac1mult;


// CAboutDlg dialog used for App About
class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CSample0Dlg dialog


CSample0Dlg::CSample0Dlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CSample0Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_chan0 = 0.0f;
	m_chan1 = 0.0f;
	m_chan10 = 0.0f;
	m_chan11 = 0.0f;
	m_chan12 = 0.0f;
	m_chan13 = 0.0f;
	m_chan14 = 0.0f;
	m_chan15 = 0.0f;
	m_chan2 = 0.0f;
	m_chan3 = 0.0f;
	m_chan4 = 0.0f;
	m_chan5 = 0.0f;
	m_chan6 = 0.0f;
	m_chan7 = 0.0f;
	m_chan8 = 0.0f;
	m_chan9 = 0.0f;
	m_DAC0 = 0.0f;
	m_DAC1 = 0.0f;

	VoltsDisplay[0] = &m_chan0;
	VoltsDisplay[1] = &m_chan1;
	VoltsDisplay[2] = &m_chan2;
	VoltsDisplay[3] = &m_chan3;
	VoltsDisplay[4] = &m_chan4;
	VoltsDisplay[5] = &m_chan5;
	VoltsDisplay[6] = &m_chan6;
	VoltsDisplay[7] = &m_chan7;
	VoltsDisplay[8] = &m_chan8;
	VoltsDisplay[9] = &m_chan9;
	VoltsDisplay[10] = &m_chan10;
	VoltsDisplay[11] = &m_chan11;
	VoltsDisplay[12] = &m_chan12;
	VoltsDisplay[13] = &m_chan13;
	VoltsDisplay[14] = &m_chan14;
	VoltsDisplay[15] = &m_chan15;

	DACDisplay[0] = &m_DAC0;
	DACDisplay[1] = &m_DAC1;

}

void CSample0Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT0, m_chan0);
	DDX_Text(pDX, IDC_EDIT1, m_chan1);
	DDX_Text(pDX, IDC_EDIT10, m_chan10);
	DDX_Text(pDX, IDC_EDIT11, m_chan11);
	DDX_Text(pDX, IDC_EDIT12, m_chan12);
	DDX_Text(pDX, IDC_EDIT13, m_chan13);
	DDX_Text(pDX, IDC_EDIT14, m_chan14);
	DDX_Text(pDX, IDC_EDIT15, m_chan15);
	DDX_Text(pDX, IDC_EDIT2, m_chan2);
	DDX_Text(pDX, IDC_EDIT3, m_chan3);
	DDX_Text(pDX, IDC_EDIT4, m_chan4);
	DDX_Text(pDX, IDC_EDIT5, m_chan5);
	DDX_Text(pDX, IDC_EDIT6, m_chan6);
	DDX_Text(pDX, IDC_EDIT7, m_chan7);
	DDX_Text(pDX, IDC_EDIT8, m_chan8);
	DDX_Text(pDX, IDC_EDIT9, m_chan9);
	DDX_Text(pDX, IDC_EDIT16, m_DAC0);
	DDX_Text(pDX, IDC_EDIT17, m_DAC1);
	DDX_Control(pDX, IDC_STATIC_DAC1, m_StaticCntrlDAC1);
	DDX_Control(pDX, IDC_STATIC_DAC0, m_StaticCntrlDAC0);
	DDX_Control(pDX, IDC_STATIC_BOARD, m_StaticCntrlBoard);
	DDX_Control(pDX, IDC_SPIN_DAC0, m_spinDAC0);
	DDX_Control(pDX, IDC_SPIN_DAC1, m_spinDAC1);
}

BEGIN_MESSAGE_MAP(CSample0Dlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_BEGIN, &CSample0Dlg::OnBnClickedButtonBegin)
	ON_BN_CLICKED(IDC_BUTTON_END, &CSample0Dlg::OnBnClickedButtonEnd)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN1, &CSample0Dlg::OnDeltaposSpin1)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN2, &CSample0Dlg::OnDeltaposSpin2)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CSample0Dlg message handlers

BOOL CSample0Dlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Detect correct card is present:
	int I, NumCards;
	unsigned long Status, Buf;

	CardNum = 0xFFFFFFFF;
	NumCards = GetNumCards();
	for( I = 0;  I < NumCards; I++ )
	{
		Status = QueryCardID(I, &Buf);
		if( Status != ERROR_SUCCESS ) continue; //Failed to query ID.
		if( Buf != 0x1ECE8) continue; //Not the ID of the 104-AIO16E.
		Status = QueryCardBase(I, &Buf);
		if( Status != ERROR_SUCCESS) continue;

		//We've successfully queried it and found the card we're looking for.
		CardNum = I;
		break;
	}

	CString strtemp;

	if ( CardNum == 0xFFFFFFFF) 
	{
		//DetectLabel->SetWindowText("No 104-AIO16E found; make sure it's installed in Device Manager.");
		strtemp = "No 104-AIO16E found; make sure it's installed in Device Manager.";
		m_StaticCntrlBoard.SetWindowTextW(strtemp);
	}
	else
	{
		CString Buf;
		Buf.Format(_T("104-AIO16E found as card number %d. Click Begin to begin acquisition."), CardNum);
		m_StaticCntrlBoard.SetWindowTextW(Buf);
		//DetectLabel->SetWindowText(Buf);
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSample0Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSample0Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSample0Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CSample0Dlg::OnBnClickedButtonBegin()
{
	// Check for card and state then configure it then start a timer

	if ( CardNum == 0xFFFFFFFF )
	{
		Beep(1000, 100);
		//DetectLabel->Font->Color = 0xFFFFFF;
		//DetectLabel->Color = 0x0000FF;
		return;
	}

	RelOutPortB(CardNum, 0x1B, 0x1F); // reset all possible states on the device, most desirably the ADC FIFO -- note: the value 0x10 should accomplish this as well.

	//Initialize the global variables and then calibrate the card
	init();
	doCAL();

	//determine if card is in single ended or differential mode
	if ( (jumpers & 0x2) != 0 )
		channels = 16;
	else
		channels = 8;
    
	//tell the card to take one reading per channel using Scan Start
	RelOutPortB(CardNum, 0x11, 0x04); //Set ADC SCAN MODE and SOFTWARE START
	//tell the board which channels we are interested in. bits 0-3 are the start
	// channel and bits 4-7 are the end channel
	RelOutPortB(CardNum, 0x06, (channels - 1) * 0x10); //setup channels zero to maxchan

	//determine the dac range and output it to the user
	CString strTemp;
	if( (dacArange & 0x1) == 1 )
	{
		strTemp = "DAC 0 output range is 0 to 5 volts";
		m_StaticCntrlDAC0.SetWindowTextW(strTemp);
	}
	else
	{
		strTemp = "DAC 0 output range is 0 to 10 volts";
		m_StaticCntrlDAC0.SetWindowTextW(strTemp);
	}

	if( (dacBrange & 0x1) == 1 )
	{
		strTemp = "DAC 1 output range is 0 to 5 volts";
		m_StaticCntrlDAC1.SetWindowTextW(strTemp);
	}
	else
	{
		strTemp = "DAC 1 output range is 0 to 10 volts";
		m_StaticCntrlDAC1.SetWindowTextW(strTemp);
	}

	// Start a timer id 1 :
	SetTimer(1, 200, 0);
}


void CSample0Dlg::OnBnClickedButtonEnd()
{
	// Just stop the timer
	KillTimer(1);
}

// Adjust the multiplier for DAC0 based on the user clicking the spinnner control
void CSample0Dlg::OnDeltaposSpin1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

	// Adjust:
	if( pNMUpDown->iDelta < 0 )
		dac0mult += 1.0;
	else
		dac0mult -= 1.0;

	if( dac0mult > 10.0 )
		dac0mult = 0.0;
	else if( dac0mult < 0.0 )
		dac0mult = 10.0;

	*pResult = 0;
}


void CSample0Dlg::OnDeltaposSpin2(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

	if( pNMUpDown->iDelta < 0 )
		dac1mult += 1.0;
	else
		dac1mult -= 1.0;

	if( dac1mult > 10.0 )
		dac1mult = 0.0;
	else if ( dac1mult < 0.0 )
		dac1mult = 10.0;

	*pResult = 0;
}


void CSample0Dlg::OnTimer(UINT_PTR nIDEvent)
{
	// Sample data:
	double bpAdjust, gainAdjust, value;
	
	//timer1.Enabled := false; //`@

	//determine the range and if the card is unipolar or bipolar
	// this is used to convert the counts to volts
	if( ((jumpers) & 0x1) != 0 )
		bpAdjust = 0.5;
	else
		bpAdjust = 0.0;

	if ( ((jumpers) & 0x4) != 0 )
		gainAdjust = 10.0;
	else
		gainAdjust = 20.0;

	RelOutPortB(CardNum, 1, 0);  //issue a software start (in this case start SCAN)

	//read the values from the FIFO, convert to volts, and display to the user
	value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
	m_chan0 = value;

	value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
	m_chan1 = value;

	value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
	m_chan2 = value;

	value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
	m_chan3 = value;

	value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
	m_chan4 = value;

	value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
	m_chan5 = value;

	value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
	m_chan6 = value;

	value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
	m_chan7 = value;

	if ( channels == 16 )
	{
		value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
		m_chan8 = value;

		value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
		m_chan9 = value;

		value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
		m_chan10 = value;

		value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
		m_chan11 = value;

		value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
		m_chan12 = value;

		value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
		m_chan13 = value;

		value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
		m_chan14 = value;

		value = ((RelInPort(CardNum, 0)/65536.0) - bpAdjust) * gainAdjust;
		m_chan15 = value;
	}
	//output the dac values and then put outputted values to screen
	if( (dacArange & 0x1) != 0 )
		value = DAC(0, dac0mult * 0.5);
	else
		value = DAC(0, dac0mult);

	m_DAC0 = value;

	if( (dacBrange & 0x1) != 0 )
		value = DAC(1, dac1mult * 0.5);
	else
		value = DAC(1, dac1mult);
	m_DAC1 = value;

	UpdateData(false);

	//timer1.Enabled := true; //`@
	CDialogEx::OnTimer(nIDEvent);
}

